#include "mbed.h"
#include "rtos.h"

#if 1
#include "EthernetInterface.h"
 
#define ECHO_SERVER_PORT   5000

int main (void) 
{
	printf("Wait a second...\r\n");
	uint8_t mac_addr[6] = {0x00, 0x08, 0xDC, 0x1D, 0xED, 0x76}; 
	EthernetInterface eth;
	eth.init(mac_addr); //Use DHCP
	eth.connect();
	printf("Server IP Address is %s\r\n", eth.getIPAddress());
	
	TCPSocketServer server;
	server.bind(ECHO_SERVER_PORT);
	server.listen();
	
	while (true) 
	{
		printf("Wait for new connection...\r\n");
		TCPSocketConnection client;
		server.accept(client);
		client.set_blocking(false, 15000); // Timeout after (1.5)s
		
		printf("Connection from: %s\r\n", client.get_address());
		char buffer[256];
		while (true) {
			int n = client.receive(buffer, sizeof(buffer));
			if (n <= 0) break;
			
			// print received message to terminal
			buffer[n] = '\0';
			printf("Received message from Client :'%s'\r\n",buffer);
			
			// reverse the message
			char temp;
			for(int f = 0, l = n-1; f<l; f++,l--){
				temp = buffer[f];
				buffer[f] = buffer[l];
				buffer[l] = temp;
				}
			
			// print reversed message to terminal
			printf("Sending message to Client: '%s'\r\n",buffer);
			
			// Echo received message back to client
			client.send_all(buffer, n);
			if (n <= 0) break;
		}
		
		client.close();
	}
	
}

#else
DigitalOut led1(LED1);
DigitalOut led2(LED2);
//DigitalOut led3(LED3);

void led2_thread(void const *args) {
	while(true) {
		led2 = ! led2;
		//printf("Changed LED2...\r\n");
		Thread::wait(1000);
	}
}

// main() runs in its own thread in the OS
// (note the calls to Thread::wait below for delays)
int main() {
	//led1 = 0;
	//led2 = 1;
	//led3 = 1;
	Thread thread(led2_thread);
	printf("Initialized thread...\r\n");

    while (true) {
		led1 = !led1;
		//printf("Changed LED1...\r\n");
        Thread::wait(500);
    }
}
#endif

